*******************************************************************************
*                 Office of State Aid Road Construction, MDOT                 *
* =========================================================================== *
*                                                                             *
* Application: Contract Estimate Program ('96)                                *
* Title......: S_HEADER.PRG                                                   *
* Description: Program to create project header entries                       *
* Written by.: James E. Maher, Jr., EI                                        *
* Date.......: 02-21-1996                                                     *
* Revised....: 07-29-2013                                                     *
*              07-08-2014  MAGIC vendor update                                *
*              10-26-2015  Add TTDG Projects                                  *
*              01-27-2017  Add EFL Projects                                   *
*                                                                             *
*******************************************************************************

*NOTE: ESTIMATE NO. MUST BE = 0 FOR THIS MENU (USE GET_PROJ TO SCREEN)
*NOTE: NEW & DELETE (ALL) REQUIRE EXCLUSIVE USE OF FILES
*NOTE: FILES-> PROJECT (INFO), DHEADER (ENGR'S EST, 900, 902), EST_HEAD & ACCT001 (MAT)

PUBLIC EFILE, HTYPE, ZFUND,ZFANUM,ZSEC,ZUNIT,ZPT,ZD_CODE,ZD_CX

public n,d,p1,p2

* ͻ
*   POPUPS  
* ͼ
DEFINE POPUP SHP_1 FROM 7,27 COLOR W/B,W+/B,GR+/BG,,W+/B,GR+/R SHADOW            && MAIN
DEFINE BAR 2 OF SHP_1 PROMPT " PROJECT HEADER MENU " COLOR W+/B SKIP
DEFINE BAR 3 OF SHP_1 PROMPT "" COLOR W+/B SKIP
DEFINE BAR 4 OF SHP_1 PROMPT "  1. CREATE / EDIT ";
  MESSAGE "Create or edit a project's header set."
DEFINE BAR 6 OF SHP_1 PROMPT "  2. DELETE  ";
  MESSAGE "Delete a project's header set."
DEFINE BAR 8 OF SHP_1 PROMPT "  0. EXIT ";
  MESSAGE 'Exit this Menu.'
DEFINE BAR 9 OF SHP_1 PROMPT " " SKIP
ON SELECTION POPUP SHP_1 DO CSEL

DEFINE POPUP SHP_2 FROM 7,27 COLOR W/B,W+/B,GR+/BG,,W+/B,GR+/R SHADOW            && TYPE SELECT
DEFINE BAR 2 OF SHP_2 PROMPT " PROJECT HEADER TYPE MENU " COLOR W+/B SKIP
DEFINE BAR 3 OF SHP_2 PROMPT "" COLOR W+/B SKIP
DEFINE BAR 4 OF SHP_2 PROMPT "  1. ENGINEER'S ESTIMATE  ";
  MESSAGE "Engineer's Preliminary Estimate."
DEFINE BAR 5 OF SHP_2 PROMPT "  2. SECTION 900 ";
  MESSAGE 'Contract documents Section 900.'
DEFINE BAR 6 OF SHP_2 PROMPT "  3. SECTION 902  ";
  MESSAGE 'Contract documents Section 902.'
DEFINE BAR 7 OF SHP_2 PROMPT "  4. ESTIMATE MAT ";
  MESSAGE 'Estimate Mat (CAD-001).'
DEFINE BAR 8 OF SHP_2 PROMPT "  0. EXIT ";
  MESSAGE 'Exit this Menu.'
DEFINE BAR 9 OF SHP_2 PROMPT " " SKIP
ON SELECTION POPUP SHP_2 DO CSEL

* ͻ
*   MENUS  
* ͼ
DEFINE MENU SHM_1 COLOR ,N/W,,,,GR+/N,R/W
DEFINE PAD NO OF SHM_1 PROMPT '\<NO' AT 7,37
DEFINE PAD YES OF SHM_1 PROMPT '\<YES' AT 7,29
ON SELECTION MENU SHM_1 DEACTIVATE MENU

DEFINE MENU SHM_2 COLOR ,GR+/B,,,,GR+/R,BG+/B
DEFINE PAD CT OF SHM_2 PROMPT '\<CONTINUE' AT 24,30
DEFINE PAD ED OF SHM_2 PROMPT '\<EDIT' AT 24,44
ON SELECTION MENU SHM_2 DEACTIVATE MENU

* ͻ
*   WINDOWS  
* ͼ
DEFINE WINDOW SHW_1 FROM 8,3 TO 17,76 DOUBLE COLOR N/W,GR+/R,GR+/BG
**<<<>>>**

* ͻ
*   PROGRAM  
* ͼ
DO WHILE .T.
  CLOSE DATA
  DO SCRT
  DO WHILE .T.
    CLEA TYPE
    ACTIVATE POPUP SHP_1
    IF BAR()=0
      ?? CHR(7)
      LOOP
    ENDIF
    EXIT
  ENDDO
  DO CASE
    CASE BAR()=4                        && ADD / EDIT
      FC='1'
      DO A_U_HEAD
    CASE BAR()=6                        && DELETE ALL HEADER/PROJ
      FC='4'
      DO D_HEAD
      IF (.NOT. ACCESS .OR. NO_LOCK).AND. GP
        CLOSE DATA
        WYN=.F.
        ACCESS=.T.
        NO_LOCK=.F.
        WARN2='HEADER FILE IN USE BY ANOTHER,'
        WARN3='CANNOT PROCEDE WITH DELETE.'
        ?? CHR(7)
        DO WARNING
      ENDIF
    CASE BAR()=8
      EXIT
  ENDCASE
ENDDO
RELEASE POPUPS SHP_1, SHP_2
RELEASE MENUS SHM_1, SHM_2
RELEASE WINDOW SHW_1
RELEASE ALL EXCEPT VER
RETURN                                          && PROGRAM S_HEADER.PRG
***<<<<<>>>>>***

* ͻ
*   PROCEDURES  
* ͼ
PROCEDURE A_U_HEAD                              && ADD / EDIT
*-----------------
DO GET_PROJ                     && SELECT PROJECT GET PROJECT W/" NOT LISTED" OPTION
DO WHILE .T.
  CLEA TYPE
  ACTIVATE POPUP SHP_2           && SELECT TYPE
  IF BAR()=0
    ?? CHR(7)
    LOOP
  ENDIF
  EXIT
ENDDO
DO CASE
  CASE BAR()= 4
    HTYPE='REPL ENGR WITH .T.'
    EFILE='A_U_EE'
  CASE BAR()= 5
    HTYPE='REPL S900 WITH .T.'
    HTYPE='REPL S902 WITH .T.'
    EFILE='A_U_900'
  CASE BAR()= 6
    EFILE='A_U_900'
  CASE BAR()= 7
    EFILE='A_U_CAD'
    HTYPE='a=1'
**    HTYPE='REPL EMAT WITH .T.'
  CASE BAR()= 8
    RETURN
ENDCASE
IF MPROJ='NOT LISTED'
&& ALL NEW PROJECT
  DO START_NEW
ELSE
  PROJ=MPROJ
ENDIF
DO &EFILE
*if efile='A_U_CAD'
*  REPL EMAT WITH .T.
*endif
RETURN                                          && PROCEDURE A_U_HEAD

PROCEDURE START_NEW                             && START A NEW PROJECT
*------------------
CLOSE DATA
NO_LOCK=.F.
SELECT 1
USE PROJECT ORDER PROJ
IF .NOT. ACCESS
  ACCESS=.T.
  RETURN
ENDIF
ACTIVATE WINDOW SHW_1
@  0,25 SAY 'NEW PROJECT INFORMATION'
@  2, 2 SAY 'PROJECT....:                       COUNTY.....:'
*****@  4, 7 SAY '             ENGLISH OR METRIC (E or M):'								&& MOD FOR 2004 SPECS
@  4, 2 SAY 'SPECIFICATIONS:'
STORE SPACE(20) TO PROJ, CO
STORE 'E' TO UN
STORE 0 TO SX															&& MOD FOR 2004 SPECS
DO WHILE .T.
  @  6, 0
  @  2,15 GET PROJ FUNC'!' VALID IIF(LEN(ALLTRIM(PROJ))>=5,.T.,.F.)
  @  2,50 GET CO FUNC'!' VALID IIF(LEN(ALLTRIM(CO))>=3,.T.,.F.)
*****  @  4,48 GET UN PICT '!' VALID IIF(UN='M'.OR.UN='E',.T.,.F.)
  @  4,18 GET SX FUNCTION '*RH 2004;1989;1995 (METRIC)' 								&& MOD FOR 2004 SPECS
  READ
  @  6,28 SAY 'IS THIS CORRECT?' COLOR R/W

**********************
* MOD FOR 2004 SPECS *
**********************
DO CASE
  CASE SX=1
	SP='2004'
  CASE SX=2
	SP='1989'
  CASE SX=1	
      SP='1995'
	UN='M'
  OTHERWISE
      LOOP
ENDCASE	
**************************
* END MOD FOR 2004 SPECS *
**************************


  DO WHILE .T.
    CLEA TYPE
    ACTIVATE MENU SHM_1
    IF PAD()=' '
      ?? CHR(7)
      LOOP
    ENDIF
    EXIT
  ENDDO
  IF PAD()='NO'
    LOOP
  ENDIF
  PROJ=ALLTRIM(PROJ)
  projx=proj
  DO TRANSLATE
  IF ERR
    ERR=.F.
    LOOP
  ENDIF
*
*-> MOD. 06-14-2001 START
*
  SELECT 7
  USE COUNTIES
  LOCATE FOR COUNTY=CO
  IF .NOT. FOUND()
    USE
    SELECT 1
*    WYN=.T.
    WYN=.T.
*    WARN3='NO SUCH COUNTY: '+ALLTRIM(CO)
    WARN2=ALLTRIM(CO)
    WARN3='IS THIS A CITY OR TOWN?'
    ?? CHR(7)
    DO WARNING
    IF PAD()='NAY'
      LOOP
    ENDIF
  ENDIF
*
*-> MOD. 06-14-2001 END
*

  SELECT 1
  DEACTIVATE WINDOW SHW_1
  EXIT
ENDDO
SEEK PROJ
IF FOUND()
  DO &EFILE                     && EDIT EXISTING
  RETURN
ENDIF
MPROJ=ALLTRIM(PROJ)
XYZ=BOX('CREATING &MPROJ...',12)
SET ORDER TO
DO LOCK_NEW
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE PROJECT EXCLUSIVE
  APPEND BLANK
  USE
  USE PROJECT
  GO BOTTOM
  Q= RLOCK()
ENDIF
SELECT 3
USE DHEADER
IF .NOT. ACCESS
  ACCESS=.T.
  RETURN
ENDIF
DO LOCK_NEW
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE DHEADER EXCLUSIVE
  APPEND BLANK
  USE
  USE DHEADER
  GO BOTTOM
  Q= RLOCK()
ENDIF
SELECT 4
USE EST_HEAD
IF .NOT. ACCESS
  ACCESS=.T.
  RETURN
ENDIF
DO LOCK_NEW
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE EST_HEAD EXCLUSIVE
  APPEND BLANK
  USE
  USE EST_HEAD
  GO BOTTOM
  Q= RLOCK()
ENDIF
SELECT 5
USE ACCT001
IF .NOT. ACCESS
  ACCESS=.T.
  RETURN
ENDIF
DO LOCK_NEW
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE ACCT001 EXCLUSIVE
  APPEND BLANK
  USE
  USE ACCT001
  GO BOTTOM
  Q= RLOCK()
ENDIF
PFX=PROJ                        && ROUTINE TO GET PAY ITEM DBF NAME
ZZ=0
XW=AT("\",PFX)
XX=AT("/",PFX)
XY=AT("-",PFX)
XZ=AT(" ",PFX)
DO CASE
  CASE XW>0
    ZZ=XW
  CASE XX>0
    ZZ=XX
  CASE XY>0
    ZZ=XY
  CASE XZ>0
    ZZ=XZ
ENDCASE
*-> 08-17-2011
IF ZZ>0 .AND. LEFT(PFX,ZZ-1)<>'SAP'.AND.LEFT(PFX,ZZ-1)<>'LSBP'.AND.LEFT(PFX,ZZ-1)<>'LSRP'.AND.;
  LEFT(PFX,ZZ-1)<>'DECD'.and.LEFT(PFX,ZZ-1)<>'LPG'.AND.LEFT(PFX,ZZ-1)<>'BR'.AND.LEFT(PFX,ZZ-1)<>'SEMP'
  PFX=STUFF(PFX,1,(ZZ-1),LEFT(PFX,2))
ENDIF
*-> 08-17-2011
*****************************
* BEGIN NEW CODE 03-22-2001 *
*****************************
if left(projx,2)='MS'
  pfx=projx
endif
***************************
* END NEW CODE 03-22-2001 *
***************************

*===========================*
* BEGIN NEW CODE 06-14-2001 *
*===========================*
if left(projx,4)='DECD'
  pfx='DD'+right(projx,(len(projx)-4))
endif
*=========================*
* END NEW CODE 06-14-2001 *
*=========================*

*===========================*
* BEGIN NEW CODE 12-14-2009 *
*===========================*
if left(projx,4)='EFLH'
  pfx='EF'+right(projx,(len(projx)-4))
endif
if left(projx,4)='RSIP'
  pfx='RP'+right(projx,(len(projx)-4))
endif
*=========================*
* END NEW CODE 12-14-2009 *
*=========================*

*===========================*
* BEGIN NEW CODE 01-27-2017 *
*===========================*
if left(projx,4)='EFL-'
  pfx='EF'+right(projx,(len(projx)-3))
endif
*=========================*
* END NEW CODE 01-27-2017 *
*=========================*

*===========================*
* BEGIN NEW CODE 07-29-2013 *
*===========================*
if left(projx,6)='STP/BR'
  pfx='ST'+right(projx,(len(projx)-6))
endif
*=========================*
* END NEW CODE 07-29-2013 *
*=========================*

                                      
DO WHILE .T.
  IF AT("-",PFX)>0
    PFX=STUFF(PFX,AT("-",PFX),1,'')
  ELSE
    EXIT
  ENDIF
ENDDO
DO WHILE .T.
  IF AT("/",PFX)>0
    PFX=STUFF(PFX,AT("/",PFX),1,'')
  ELSE
    EXIT
  ENDIF
ENDDO
DO WHILE .T.
  IF AT("\",PFX)>0
    PFX=STUFF(PFX,AT("\",PFX),1,'')
  ELSE
    EXIT
  ENDIF
ENDDO
DO WHILE .T.
  IF AT("(",PFX)>0
    PFX=STUFF(PFX,AT("(",PFX),1,'')
  ELSE
    EXIT
  ENDIF
ENDDO
DO WHILE .T.
  IF AT(")",PFX)>0
    PFX=STUFF(PFX,AT(")",PFX),1,'')
  ELSE
    EXIT
  ENDIF
ENDDO
DO WHILE .T.
  IF AT(" ",PFX)>0
    PFX=STUFF(PFX,AT(" ",PFX),1,'')
  ELSE
    EXIT
  ENDIF
ENDDO
*****************************
* BEGIN NEW CODE 09-03-2002 *
*****************************
if left(projx,2)="MS" .or. left(projx,3)="FBD" .or. left(projx,4)="TCSP" .or. left(projx,4)="NCPD"
  MFN=allt(left(PFX,1)+subs(PFX+space(8),3,8))
else
  MFN=LEFT(PFX,8)
endif
***************************
* END NEW CODE 09-03-2002 *
***************************
SELECT 1                        && PROJECT
REPL PROJECT WITH PROJ
REPL COUNTY WITH CO
REPL FUND WITH ZFUND
REPL FANUM WITH ZFANUM
REPL SEC WITH ZSEC
REPL UNIT WITH ZUNIT
REPL PT WITH ZPT
REPL PROJ_NUM WITH ZD_CODE
&HTYPE
REPL PIFN WITH MFN
REPL UNITS WITH UN
REPL SPECS WITH SP
SELECT 3                        && DHEADER
REPL PROJ_NO WITH PROJ
REPL COUNTY WITH CO
*REPL BOARD_PRES WITH COUNTIES->BOARD_PRES
*REPL BID_WHERE WITH COUNTIES->CO_SEAT
*REPL BID_HOUR WITH '10'
*REPL BID_MIN WITH '00'
*REPL BID_AP WITH 'A'
REPL FUND WITH ZFUND
REPL FANUM WITH ZFANUM
REPL SEC WITH ZSEC
REPL UNIT WITH ZUNIT
REPL PT WITH ZPT
REPL PROJ_NUM WITH ZD_CODE
REPL UNITS WITH UN
REPL SPECS WITH SP
SELECT 4                        && EST_HEAD
REPL PROJ_PFX WITH PROJ
REPL COUNTY WITH CO
REPL PERC_RET WITH 5
REPL FUND WITH ZFUND
REPL FANUM WITH ZFANUM
REPL SEC WITH ZSEC
REPL UNIT WITH ZUNIT
REPL PT WITH ZPT
REPL PROJ_NUM WITH ZD_CODE
REPL NUM_PAGES WITH 2
SELECT 5                        && ACCT001
REPL PROJECT WITH PROJ
REPL TPCDETAIL WITH ZD_CX
REPL TNPDETAIL WITH ZD_CX
REPL TOTDETAIL WITH ZD_CX
REPL TWDDETAIL WITH ZD_CX
REPL RETDETAIL WITH ZD_CX
REPL LDDETAIL WITH ZD_CX
REPL PROJ_NUM WITH ZD_CODE
SELECT 25
USE ADV
COPY TO &DATA.&MFN..ADV
USE CHGFILE
COPY TO &DATA.&MFN..CHG
USE DEDFILE
COPY TO &DATA.&MFN..DED
USE FUEL_ADJ
COPY TO &DATA.&MFN..FAD
USE RETFILE
COPY TO &DATA.&MFN..RET
USE
MPROJ=PROJ
SET SAFETY OFF
SAVE ALL LIKE M* TO &TEMP.PROJ
SET SAFETY ON
DEACTIVATE WINDOW BOX
RETURN                                          && PROCEDURE START_NEW

PROCEDURE TRANSLATE                             && TRANSLATES PROJECT NUMBER INTO DETAIL CODE
*------------------
DO WHILE AT("_",PROJ)>0
  PROJ=STUFF(PROJ,AT("_",PROJ),1,"-")
ENDDO
LP=LEN(PROJ)
DO CASE
  CASE AT("RRS",PROJ)>0
    ZFUND="01"
    N=3
  CASE AT("RRP",PROJ)>0
    ZFUND="02"
    N=3
*****************************
* BEGIN NEW CODE 03-22-2001 *
*****************************
  CASE AT("MS",PROJ)>0 
    ZFUND="19"
    N=2
***************************
* END NEW CODE 03-22-2001 *
***************************
  CASE AT("TTDG",PROJ)>0				&& TTDG added 10-26-2015
    ZFUND="22"
    N=4
  CASE AT("GR",PROJ)>0 
    ZFUND="25"
    N=2
  CASE at("HRRR",proj)>0				&& HRRR added 01-16-2008
    ZFUND="25"
    N=4
  CASE AT("STPG",PROJ)>0
    ZFUND="32"
    N=4
  CASE AT("STPD",PROJ)>0				&& STPD added 05-02-2011
    ZFUND="82"
    N=4
  CASE AT("RSG",PROJ)>0
    ZFUND="32"
    N=3
  CASE AT("AHL",PROJ)>0
    ZFUND="34"
    N=3
  CASE AT("APL",PROJ)>0
    ZFUND="36"
    N=3
  CASE AT("CFP",PROJ)>0
    ZFUND="39"
    N=3
*->Start 08-28-2001
  CASE AT("PLH",PROJ)>0
    ZFUND="62"
    N=3
*->End 08-28-2001
  CASE AT("NAD",PROJ)>0
    ZFUND="64"
    N=3
  CASE AT("RAD",PROJ)>0
    ZFUND="64"
    N=3
  CASE AT("AD",PROJ)>0
    ZFUND="64"
    N=2
  CASE AT("AG",PROJ)>0
    ZFUND="64"
    N=2
  CASE AT("ER",PROJ)>0
    ZFUND="66"
    N=2
  CASE AT("DPC",PROJ)>0
    ZFUND="68"
    N=3
*-> 08-17-2011
  CASE AT("SEMP",PROJ)>0
    ZFUND="81"
    N=4
*-> 08-17-2011
*-> 09-18-2001
  CASE AT("LSRP",PROJ)>0
    ZFUND="81"
    N=4
*-> 09-18-2001
  CASE AT("DECD",PROJ)>0
    ZFUND="81"
    N=4
  CASE AT("LSBP",PROJ)>0
    ZFUND="81"
    N=4
  CASE AT("SAP",PROJ)>0
    ZFUND="81"
    N=3
  CASE AT("LPG",PROJ)>0
    ZFUND="81"
    N=3
  CASE AT("MS",PROJ)>0
    ZFUND="81"
    N=4
*-> 12-14-2009
  CASE AT("RSIP",PROJ)>0  
    ZFUND="25"
    N=4
*-> 12-14-2009
  CASE AT("RS",PROJ)>0
    ZFUND="82"
    N=2
  CASE AT("SECG",PROJ)>0
    ZFUND="84"
    N=4
  CASE AT("BR",PROJ)>0
    N=2
    ZFUND="85"
  CASE AT("STP/EGC",PROJ)>0
    ZFUND="82"
    N=7
  CASE AT("STP",PROJ)>0
    ZFUND="82"
    N=-1
*-> 08-26-2002
  CASE AT("FBD",PROJ)>0
    ZFUND="19"
    N=3
*-> 08-26-2002
*-> 09-03-2002 
  CASE AT("TCSP",PROJ)>0   
    ZFUND="19"
    N=4
*-> 09-03-2002
*-> 06-23-2003
  CASE AT("NCPD",PROJ)>0  
    ZFUND="19"
    N=4
*-> 06-23-2003
*-> 09-02-2009
  CASE AT("EFLH",PROJ)>0  
    ZFUND="90"
    N=4
*-> 09-02-2009
*-> 01-27-2017
  CASE AT("EFL",PROJ)>0  
    ZFUND="90"
    N=3
*-> 01-27-2017

  OTHERWISE
    WARN2='IS '+ALLTRIM(PROJ)+' A COUNTY'
    WARN3='(NON-STATE AID ADMINISTERED) PROJECT?'
    WYN=.T.
    ?? CHR(7)
    DO WARNING
    IF PAD()='YEA'
      ZFUND='99'
      RESTORE FROM CO_PROJ ADDITIVE
      ZCP=ZCP+1
      SET SAFETY OFF
      SAVE ALL LIKE ZCP TO CO_PROJ
      SET SAFETY ON
      ZZ=RIGHT('00000000000'+ALLTRIM(STR(ZCP)),11)
      ZFANUM=LEFT(ZZ,4)
      ZSEC=SUBS(ZZ,5,2)
      ZUNIT=SUBS(ZZ,7,3)
      ZPT=RIGHT(ZZ,2)
    ELSE
      WARN3="ERROR!  PROJECT NUMBER IS NOT VALID."
      WYN=.F.
      ?? CHR(7)
      DO WARNING
      ERR=.T.
      RETURN
    ENDIF
ENDCASE
IF ZFUND<>'99'
  IF ZFUND="81"
    D=MAX(AT("-",PROJ),AT(" ",PROJ))
    P1= AT("(",PROJ)
    IF P1=0
      P1=AT(" ",RIGHT(PROJ,LP-D-1))+D+1
    ENDIF
    P2=AT(")",PROJ)
    IF P2=0
      P2=AT(" ",RIGHT(PROJ,LP-P1-1))
      IF P2=0.OR.P2=LP
        P2=LP+1
      ELSE
        P2=P2+P1+1
      ENDIF
    ENDIF
    PROJ=STUFF(PROJ,D,1,"-")
    PROJ=STUFF(PROJ,P1,1,"(")
    PROJ=STUFF(PROJ,P2,1,")")
    ZFANUM=SUBS(PROJ,N+2,P1-(N+2))
    ZUNIT=SUBS(PROJ,P1+1,P2-P1-1)
    ZFANUM=RIGHT("0000"+ZFANUM,4)
    ZUNIT=RIGHT("000"+ZUNIT,3)
    DO CASE
      CASE RIGHT(PROJ,1)="S"
        ZSEC="10"
      CASE RIGHT(PROJ,1)="M"
        ZSEC="20"
      CASE LEFT(PROJ,4)='DECD'
        ZSEC="30"
      CASE LEFT(PROJ,4)='LSBP'
        ZSEC="40"
      CASE LEFT(PROJ,3)='LPG'
        ZSEC="50"
*-> 09-18-2001
      CASE LEFT(PROJ,4)='LSRP'
        ZSEC="60"
*-> 09-18-2001
*-> 10-19-2001
      CASE right(PROJ,2)='TP'
        ZSEC="70"
*-> 10-19-2001
*-> 08-17-2011
      CASE LEFT(PROJ,4)='SEMP'
        ZSEC="80"
*-> 08-17-2011
      OTHERWISE
        ZSEC="00"
    ENDCASE
  ELSE
    XX=0
** 08-15-2001**    IF AT("STP",PROJ)>0 .and. at("EGC",proj)=0 
** 05-02-2011**    IF AT("STP",PROJ)>0 .and. at("EGC",proj)=0 .and. left(proj,4)<>"STPG"
    IF AT("STP",PROJ)>0 .and. at("EGC",proj)=0 .and. left(proj,4)<>"STPG" .and. left(proj,4)<>"STPD"
      XX=1
      N=N+4
    ENDIF
*    if at('DPC',proj)>0.and.at('(',proj)<9
*      proj=stuff(proj,at('-',proj)+1,0,'00')
*    endif
    P1= AT("(",PROJ)
    IF P1=0
      P1=AT(" ",RIGHT(PROJ,LP-N-1))+N+1
    ENDIF
    P2=AT(")",PROJ)
    IF P2=0
      P2=AT(" ",RIGHT(PROJ,LP-P1-1))
      IF P2=0.OR.P2=LP
        P2=LP+1
      ELSE
        P2=P2+P1+1
      ENDIF
      IF XX=1.AND.(ZFUND="85".OR.ZFUND="82").and.at("EGC",PROJ)=0
        IF LEFT(PROJ,3)="STP".AND.(SUBS(PROJ,5,2)="BR".OR.SUBS(PROJ,5,2)="RS")
          PROJ=STUFF(PROJ,4,1,"-")
        ELSE
          PROJ=STUFF(PROJ,N-3,1,"-")
        ENDIF
      ENDIF
    ENDIF
    PROJ=STUFF(PROJ,N+1,1,"-")
    PROJ=STUFF(PROJ,P1,1,"(")
    PROJ=STUFF(PROJ,P2,1,")")
    ZFANUM=SUBS(PROJ,N+2,4)
    if at('DPC',proj)>0.and.at('(',proj)<9
      ZFANUM=SUBS(PROJ,N+2,2)
    endif
    if at('STP/EGC',proj)>0
      ZFANUM=SUBS(PROJ,9,4)
    endif
    ZFANUM=RIGHT("0000"+ZFANUM,4)
    ZUNIT=SUBS(PROJ,P1+1,P2-P1-1)
    ZUNIT=RIGHT("000"+ZUNIT,3)
    ZSEC="00"
  ENDIF
  ZPT='10'
ENDIF
*****************************
* BEGIN NEW CODE 03-22-2001 *
*****************************
if left(projx,2)="MS"
  zfund='19'
  azx=at('-',projx)
  azy=at('(',projx)
  azz=azy-azx-1
  zfanum=right('0000'+subs(projx,azx+1,azz),4)
  zsec=subs(projx,4,2)
  azx=at('(',projx)
  azy=at(')',projx)
  azz=azy-azx-1
  zunit=right('000'+subs(projx,azx+1,azz),3)
  zpt='10'
  proj=projx
endif
***************************
* END NEW CODE 03-22-2001 *
***************************
ZD_CX=ZFUND+'-'+ZFANUM+'-'+ZSEC+'-'+ZUNIT+'-'+ZPT
ZD_CODE=ZFUND+ZFANUM+ZSEC+ZUNIT+ZPT
RETURN                                          && PROCEDURE TRANSLATE

PROCEDURE A_U_EE                                && ENGINEER'S ESTIMATE
*---------------
SELECT 1
USE PROJECT ORDER PROJ
SEEK MPROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 3
USE DHEADER ORDER PROJ
SEEK MPROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 7
USE COUNTIES
LOCATE FOR ALLTRIM(COUNTY)=ALLTRIM(PROJECT->COUNTY)
SELECT 3
E_TYPE='COUNTY'
PX='COUNTY..:'
E_N=COUNTIES->CE_NAME
P_T=SPACE(31)
IF PDATE={  /  /    }
  REPL PDATE WITH DATE()
ENDIF
FED=.F.
DO CASE
*-> 08-17-2011
  CASE LEFT(PROJECT->PROJECT,4)='SEMP'
    E_TYPE='SEMP'
    P_T='STATE EARMARK PROJECT'
*-> 08-17-2011
*-> 09-18-2001
  CASE LEFT(PROJECT->PROJECT,4)='LSRP'
    E_TYPE='LSRP'
    P_T='LOCAL SYSTEM ROAD PROGRAM'
*-> 09-18-2001
  CASE LEFT(PROJECT->PROJECT,4)='LSBP'
    E_N=COUNTIES->LE_NAME
    E_TYPE='LSBP'
*-> 09-18-2001  *v* revised nomenclature *v*
**    P_T='LOCAL SYSTEM BRIDGE REPLACEMENT'
    P_T='LOCAL SYSTEM BRIDGE PROGRAM'
*-> 09-18-2001
  CASE LEFT(PROJECT->PROJECT,3)='SAP'
    P_T='STATE AID'
  CASE LEFT(PROJECT->PROJECT,4)='DECD'
    IF PROJECT->FUND<>'81'
      FED=.T.
    ENDIF
    PX='LOCATION:'
    P_T='DEPT. OF ECONOMIC & COMM. DEV.'
  CASE LEFT(PROJECT->PROJECT,2)='BR'
    FED=.T.
    P_T='FEDERAL AID BRIDGE REPLACEMENT'
  CASE LEFT(PROJECT->PROJECT,3)='STP'
    FED=.T.
    P_T='SURFACE TRANSPORTATION PROGRAM'
  CASE LEFT(PROJECT->PROJECT,3)='APL'
    FED=.T.
    P_T='APPALACHIAN ACCESS HIGHWAY'
 OTHERWISE
   P_T=ALLTRIM(PROJ_TYPE)
ENDCASE
IF LEN(ALLTRIM(PROJ_TYPE))<=1
  REPL PROJ_TYPE WITH P_T
ENDIF
DO WHILE .T.
  DO SCRT
  @  3, 0 SAY "                           ENGINEER'S ESTIMATE SHEET"
  @  4, 0 SAY "                     OFFICE OF STATE AID ROAD CONSTRUCTION"
  @  5, 0 SAY "                    MISSISSIPPI DEPARTMENT OF TRANSPORTATION"
  @  7, 0 SAY "NAME OF ROAD:                                                             "
  @  8, 0 SAY "                                           PROJECT NO.                   "
  @ 10, 0 SAY "                                           DATE:                  "
  @ 10, 0 SAY PX
  @ 12, 0 SAY "TYPE:                                      LENGTH OF ROADWAY:"
  @ 13, 0 SAY "                                           LENGTH OF BRIDGE: "
  @ 14, 0 SAY "                                           LENGTH OF PROJECT:"
  @ 15, 0 SAY "WIDTH OF ROADWAY:                          LENGTH OF EXCEPTIONS:"
  @ 17, 0 SAY "SURFACING:                                 WIDTH:"
  IF UNITS="E"
    @ 12,73 SAY "MILES"
    @ 13,73 SAY "MILES"
    @ 14,73 SAY "MILES"
    @ 15,73 SAY "MILES"
    @ 17,56 SAY "FEET"
  ELSE
    @ 12,73 SAY "km"
    @ 13,73 SAY "km"
    @ 14,73 SAY "km"
    @ 15,73 SAY "km"
    @ 17,56 SAY "meters"
  ENDIF
  IF FED
    @ 19, 0 SAY "LENGTH OF NON-PARTICIPATING ROADWAY:"
    @ 19,10 SAY "NON-PARTICIPATING ROADWAY" COLOR GR+*/B
    IF UNITS='E'
      @ 19,49 SAY 'MILES'
     ELSE
      @ 19,49 SAY 'km'
    ENDIF
  ENDIF
  @ 21, 0 SAY "PREPARED BY:                               TITLE:  &E_TYPE. ENGINEER"
  @ 22, 0 SAY "DETAILED ESTIMATE OF PROPOSED WORK         ESTIMATED PRICES"
  @ 24,29 SAY '<< OK >> << EDIT >>' COLOR W/B
  SET COLOR TO G+/B
  IF LEN(ALLTRIM(P_T))>1
    @  7,43 SAY PROJ_TYPE
  ENDIF
  @  8,55 SAY PROJ_NO
  @ 21,13 SAY E_N
  SET COLOR TO W+/B
  IF LEN(ALLTRIM(PROJ_TYPE))<=1
    @  7,43 GET PROJ_TYPE FUNC '!'
  ENDIF
  @  7,15 GET ROAD1 FUNC '!'
  @  8,15 GET ROAD2 FUNC '!'
  @  9,15 get ROAD3 func '!'
  @  9,41 get ROAD4 func '!'
  @ 10,11 GET COUNTY FUNC '!'
  @ 10,50 GET PDATE
  @ 12, 7 GET TYPE1 FUNC '!S32'
  @ 13, 7 GET TYPE2 FUNC '!S32'
  @ 14, 7 GET TYPE3 FUNC '!S32'
  @ 12,65 GET LEN_RDWY PICT '999.999'
  @ 13,65 GET LEN_BR PICT '999.999'
  @ 14,65 GET LEN_PROJ PICT '999.999'
  @ 15,65 GET LEN_EXCP PICT '999.999'
  @ 15,19 GET WIDTH_RDWY FUNC '!'
  @ 17,13 GET SURFACING FUNC '!S25'
  @ 17,51 GET WIDTH PICT '99.9'
  IF FED
    @ 19,39 GET LEN_NP PICT '999.999'
  ENDIF

  READ
  DO WHILE .T.
    PA=0
    CLEA TYPE
    @ 24,29 GET PA FUNC '*H < \<OK >;< \<EDIT >' COLOR ,,,,,GR+/R,BG+/B,,GR+/B,W/B
    READ
    IF PA<>0
      EXIT
    ENDIF
    ?? CHR(7)
  ENDDO
  IF PA=1
    EXIT
  ENDIF
ENDDO
REPL FUND WITH PROJECT->FUND
REPL FANUM WITH PROJECT->FANUM
REPL SEC WITH PROJECT->SEC
REPL UNIT WITH PROJECT->UNIT
REPL PT WITH PROJECT->PT
*IF BID_HOUR='  '
*  REPL BID_HOUR WITH "12"
*  REPL BID_MIN WITH "00"
*ENDIF
REPL S_PDATE WITH DTOS(PDATE)
MU_TYPE=UNITS
SELECT 1
REPL ENGR WITH .T.
CLOSE DATA
RETURN                                          && PROCEDURE A_U_EE

PROCEDURE A_U_900                               && SECTION 900/902
*----------------
SELECT 1
USE PROJECT ORDER PROJ
SEEK MPROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 3
USE DHEADER ORDER PROJ
SEEK MPROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 4
USE EST_HEAD ORDER PROJ
SEEK MPROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 7
USE COUNTIES
LOCATE FOR ALLTRIM(COUNTY)=ALLTRIM(PROJECT->COUNTY)
SELECT 3
IF PROJECT->S900=.F.
  REPL BOARD_PRES WITH COUNTIES->BOARD_PRES
  REPL BID_WHERE WITH COUNTIES->CO_SEAT
  REPL BID_HOUR WITH '00'
  REPL BID_MIN WITH '00'
  REPL BID_AP WITH 'A'
  IF EST_HEAD->TIME_UNITS=SPACE(5)
    REPL WRK_DAYS WITH LEFT(ALLTRIM(EST_HEAD->TIME_UNITS),3)
  ENDIF
ENDIF
DO SCRT
@  4, 4 TO 24,74 DOUBLE COLOR BG+/B
@  3,23 TO 5,53 COLOR BG+/B
@  4,23 SAY '' COLOR BG+/B
@  4,53 SAY '' COLOR BG+/B
@  4,24 SAY ' SECTION 900/902 INFORMATION ' COLOR GR+/B
@  7,15 SAY 'PROJECT: '
@  7,24 SAY PROJECT->PROJECT COLOR G+/B
@  7,44 SAY 'COUNTY.: '
@  7,53 SAY PROJECT->COUNTY COLOR G+/B
@  9,15 SAY 'WORKING DAYS....: '
@ 11,15 SAY 'DATE OF LETTING.: '
@ 13,15 SAY 'TIME OF LETTING.:   :    M'
@ 15,15 SAY 'PLACE OF LETTING: '
@ 17,15 SAY 'BOARD PRESIDENT.: '
@ 19,15 SAY 'PRICE OF PLANS....(WORD):                  (NUMBER): $ '
@ 21,15 SAY 'PRICE OF PROPOSAL (WORD):                  (NUMBER): $ '
DO WHILE .T.
  @ 23,29 SAY '<< OK >> << EDIT >>' COLOR W/B
  @  9,33 GET WRK_DAYS PICT '!!!' VALID IIF(WRK_DAYS='N/A'.OR.VAL(WRK_DAYS)>0,.T.,.F.)
  @ 11,33 GET BID_DATE
  @ 13,33 GET BID_HOUR PICT '99'
  @ 13,36 GET BID_MIN PICT '99'
  @ 13,39 GET BID_AP PICT '!' VALID IIF(BID_AP<>'A'.AND.BID_AP<>'P',.F.,.T.)
  @ 15,33 GET BID_WHERE FUNC '!'
  @ 17,33 GET BOARD_PRES FUNC '!'
  @ 19,41 GET PL_NUM FUNC '!'
  @ 19,70 GET PL_DOLLARS PICT '999'
  @ 21,41 GET PR_NUM FUNC '!'
  @ 21,70 GET PR_DOLLARS PICT '999'
  READ
  DO WHILE .T.
    PA=0
    CLEA TYPE
    @ 23,29 GET PA FUNC '*H < \<OK >;< \<EDIT >' COLOR ,,,,,GR+/R,BG+/B,,GR+/B,W/B
    READ
    IF PA<>0
      EXIT
    ENDIF
    ?? CHR(7)
  ENDDO
  IF PA=1
    EXIT
  ENDIF
ENDDO
REPL S_BDATE WITH DTOS(BID_DATE)
SELECT 1
REPL S900 WITH .T.
REPL S902 WITH .T.
CLOSE DATA
RETURN                                          && PROCEDURE A_U_900

PROCEDURE A_U_CAD                               && CAD-001
*----------------
CLOSE DATA
SELECT 1
USE PROJECT ORDER PROJ
SEEK PROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 3
USE DHEADER ORDER PROJ
SEEK PROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 4
USE EST_HEAD ORDER PROJ
SEEK PROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 5
USE ACCT001 ORDER PROJ
SEEK PROJ
DO LOCK_EDT
IF NO_LOCK
  RETURN
ENDIF
SELECT 4
IF TIME_UNITS=SPACE(5).AND. PROJECT->S900=.T.
  REPL TIME_UNITS WITH DHEADER->WRK_DAYS
ENDIF
SELECT 5
DO WHILE .T.
  DO SCRT
  @  3, 0 SAY "CAD-001 (SA)           OFFICE OF STATE AID ROAD CONSTRUCTION"
  @  4, 0 SAY "Rev. 2-94             MISSISSIPPI DEPARTMENT OF TRANSPORTATION"
  @  5, 0 SAY "                        CONTRACTOR'S ESTIMATE - RECAP SHEET"
  @  9, 0 SAY "Vendor Number"
  @ 11, 0 SAY "Project No."
  @ 11,12 SAY EST_HEAD->PROJ_PFX COLOR G+/B
  @ 11,22 SAY "/"
  @ 11,25 SAY "-"
  @ 11,30 SAY "-"
  @ 11,33 SAY "-"
  @ 11,37 SAY "-"
  @ 11,23 SAY EST_HEAD->FUND COLOR G+/B
  @ 11,26 SAY EST_HEAD->FANUM COLOR G+/B
  @ 11,31 SAY EST_HEAD->SEC COLOR G+/B
  @ 11,34 SAY EST_HEAD->UNIT COLOR G+/B
  @ 11,38 SAY EST_HEAD->PT COLOR G+/B
  @ 11,42 SAY "County"
  @ 11,49 SAY EST_HEAD->COUNTY COLOR G+/B
  @ 11,63 SAY "Sheet No"
  @ 11,72 SAY  '1' COLOR G+/B
  @ 11,75 SAY "of"
  @ 13, 0 SAY "In Account With"
  @ 15, 0 SAY "Customer Account Number:"
  @ 15,41 SAY "Surety"
  @ 17, 0 SAY "Est. No."
  @ 17,15 SAY "(Progress-Final)    Period"
  @ 17,51 SAY "To"
  @ 17,63 SAY "Budget Code"
  @ 17,75 SAY '52-01' COLOR G+/B
**  @ 17,75 SAY  BUDCODE COLOR G+/B
  GO_BACK=.T.
  DO WHILE GO_BACK=.T.
    @ 13, 16
    MVENNO=STUFF(EST_HEAD->VENNO,AT('V',EST_HEAD->VENNO),1,'')
**    @  9, 14 SAY "V" COLOR GR+/R							&& MAGIC vendor update 07-08-2014
    @  9, 15 GET MVENNO PICT "9999999999"
    READ
**    MVENNO=LEFT("V"+ALLTRIM(MVENNO)+SPACE(11),11)				&& MAGIC vendor update 07-08-2014
    SELECT 6
    USE AV0001 ORDER VENNO
    SEEK MVENNO
    MVEN=.T.
    IF .NOT. FOUND()
      MVEN=.F.
      DO GET_VEND   && WINDOW & POPUP TO SELECT VENDOR
      MVENNO=AVEN
      @ 9,14 SAY MVENNO COLOR G+/B
    ENDIF
    ADDRESS=LTRIM(TRIM(AVENA1))
    IF AVENA2<>SPACE(30)
      ADDRESS=ADDRESS+" "+LTRIM(TRIM(AVENA2))
    ENDIF
    MCONT_NAME=LTRIM(TRIM(AVENM))+", "+ADDRESS+" "+TRIM(AVENCT)+" "+AVENST+", "+AVENZP
    @  9, 14 SAY MVENNO COLOR G+/B
    @ 13, 16 SAY LEFT(MCONT_NAME,64) COLOR G+/B
    GO_BACK=.F.
    DO OK_VEND
    if go_back=.f.
      REPL EST_HEAD->VENNO WITH MVENNO
      REPL EST_HEAD->CONT_NAME WITH MCONT_NAME    
    endif  
    SELECT 6
    USE
  ENDDO
  SELECT 5
  IF MVEN=.F.
    REPL EST_HEAD->VENNO WITH MVENNO
    REPL EST_HEAD->CONT_NAME WITH MCONT_NAME
  ENDIF
**  @ 11,12 GET EST_HEAD->PROJ_PFX FUNCTION "S9!"
**  @ 11,23 GET EST_HEAD->FUND PICT '99'
**  @ 11,26 GET EST_HEAD->FANUM PICT '9999'
**  @ 11,31 GET EST_HEAD->SEC PICT '99'
**  @ 11,34 GET EST_HEAD->UNIT PICT '999'
**  @ 11,38 GET EST_HEAD->PT PICT '99'
**  @ 11,49 GET EST_HEAD->COUNTY FUNCTION "S10!"
  @ 11,78 GET EST_HEAD->NUM_PAGES PICT '99'
**  IF AT('SAP',EST_HEAD->PROJ_PFX)=0 .AND. AT('LSBP',EST_HEAD->PROJ_PFX)=0 .AND.;
**    AT('DECD',EST_HEAD->PROJ_PFX)=0

**  IF EST_HEAD->FUND<>'81'
**    @ 15,25 GET EST_HEAD->CUST_ACCT PICT '99999999'
**  ENDIF
  @ 15,48 GET EST_HEAD->SURETY FUNCTION "S32!"
  READ
*  IF ((LEFT(LTRIM(EST_HEAD->PROJ_PFX),3)<>"SAP".AND.LEFT(LTRIM(EST_HEAD->PROJ_PFX),4)<>"LSBP");
*    .AND.EST_HEAD->CUST_ACCT= SPACE(8).OR.(LEFT(LTRIM(EST_HEAD->PROJ_PFX),4)="DECD".AND.EST_HEAD->FUND="81"));
*    .OR.EST_HEAD->SURETY = SPACE(50)

  IF EST_HEAD->SURETY=SPACE(50)
    WARN3="ERROR!  SURETY NOT ENTERED."
    WYN=.F.
    ?? CHR(7)
    DO WARNING
    LOOP
  ENDIF
  DO WHILE .T.
    CLEA TYPE
    ACTIVATE MENU SHM_2
    IF PAD()=' '
      ?? CHR(7)
      LOOP
    ENDIF
    EXIT
  ENDDO
  IF PAD()='ED'
    LOOP
  ENDIF
  EXIT
ENDDO
**DC=EST_HEAD->FUND+'-'+EST_HEAD->FANUM+'-'+EST_HEAD->SEC+'-'+EST_HEAD->UNIT+'-'+EST_HEAD->PT
**REPL TPCDETAIL WITH DC
**REPL TNPDETAIL WITH DC
**REPL TOTDETAIL WITH DC
**REPL TWDDETAIL WITH DC
**REPL RETDETAIL WITH DC
**REPL LDDETAIL WITH DC
**REPL EST_HEAD->PROJ_NUM WITH EST_HEAD->FUND+EST_HEAD->FANUM+EST_HEAD->SEC+EST_HEAD->UNIT+EST_HEAD->PT
**REPL PROJECT->PROJ_NUM WITH EST_HEAD->PROJ_NUM
**REPL PROJ_NUM WITH EST_HEAD->PROJ_NUM
DO WHILE .T.
  DO SCRT
  @  3,  2  SAY "͸"
  @  4,  2  SAY "                                                               PTP"
  @  5,  2  SAY "                                  FdAcctFunObj   Detail Code   trd"
  @  6,  2  SAY "Ĵ"
  @  7,  2  SAY "Construction Contract Cost                                        "
  @  8,  2  SAY "  Participating                                                   "
  @  9,  2  SAY "  Non-Participating                                               "
  @ 10,  2  SAY "  Total                       "
  @ 11,  2  SAY "Less Retainage at __________%                                     "
  @ 12,  2  SAY "Total Due - Regular Work      "
  @ 13,  2  SAY "Less ________________ in CD's                                     "
  @ 14,  2  SAY "                                                                  "
  @ 15,  2  SAY "                                                                  "
  @ 16,  2  SAY "Less Damages & Forfeitures                                        "
  @ 17,  2  SAY "Total Net Work Due            "
  @ 18,  2  SAY ";"
* TOTAL - PARTICIPATNG
  IF AT("CO BD OF SUP",MCONT_NAME)<>0
**    @  8, 36  GET TPCLINE
  ENDIF
  REPL TPCPT WITH '1'
*  IF AT("SAP",EST_HEAD->PROJ_PFX)<>0.OR.AT("LSBP",EST_HEAD->PROJ_PFX)<>0;
*    .OR.(AT("DECD",EST_HEAD->PROJ_PFX)<>0.AND.MFUND="81")

  IF EST_HEAD->FUND='81'.OR.EST_HEAD->FUND='99'
    REPL TPCFUND WITH 'XX'
    REPL TPCACCT WITH 'XXXX'
    REPL TPCFUNC WITH 'XXX'
    REPL TPCOBJ WITH 'XXX'
    @  8, 39  SAY TPCFUND COLOR G+/B
    @  8, 42  SAY TPCACCT COLOR G+/B
    @  8, 47  SAY TPCFUNC COLOR G+/B
    @  8, 51  SAY TPCOBJ COLOR G+/B
  ELSE
    if project->emat=.f.
      REPL TPCFUND WITH '52'
      REPL TPCACCT WITH '7215'
      REPL TPCFUNC WITH '221'
      REPL TPCOBJ WITH '351'
    endif
    @  8, 39  GET TPCFUND PICT '99'
    @  8, 42  GET TPCACCT PICT '9999'
    @  8, 47  GET TPCFUNC PICT '999'
    @  8, 51  GET TPCOBJ PICT '999'
  ENDIF
  @  8, 55  SAY TPCDETAIL COLOR G+/B
  @  8, 73  GET TPCPT PICT '9'
  @  8, 75  GET TPCTR PICT '9'
  @  8, 77  GET TPCPD PICT '9'
  READ
*  TOTAL - NON-PARTICIPATING
  IF AT("CO BD OF SUP",MCONT_NAME)<>0
**    @  9, 36  GET TNPLINE
  ENDIF
  REPL TNPFUND WITH TPCFUND
  REPL TNPACCT WITH TPCACCT
  REPL TNPFUNC WITH TPCFUNC
  REPL TNPOBJ WITH TPCOBJ
  REPL TNPDETAIL WITH TPCDETAIL
  REPL TNPPT WITH '2'
*  IF AT("SAP",EST_HEAD->PROJ_PFX)<>0.OR.AT("LSBP",EST_HEAD->PROJ_PFX)<>0;
*    .OR.(AT('DECD',EST_HEAD->PROJ_PFX)<>0.AND.MFUND="81")

  IF EST_HEAD->FUND='81'.OR.EST_HEAD->FUND='99'
    REPL TNPFUND WITH 'XX'
    REPL TNPACCT WITH 'XXXX'
    REPL TNPFUNC WITH 'XXX'
    REPL TNPOBJ WITH 'XXX'
    @  9, 39  SAY TNPFUND COLOR G+/B
    @  9, 42  SAY TNPACCT COLOR G+/B
    @  9, 47  SAY TNPFUNC COLOR G+/B
    @  9, 51  SAY TNPOBJ COLOR G+/B
  ELSE
    @  9, 39  GET TNPFUND PICT '99'
    @  9, 42  GET TNPACCT PICT '9999'
    @  9, 47  GET TNPFUNC PICT '999'
    @  9, 51  GET TNPOBJ PICT '999'
  ENDIF
  @  9, 55  SAY TNPDETAIL COLOR G+/B
  @  9, 73  GET TNPPT PICT '9'
  @  9, 75  GET TNPTR PICT '9'
  @  9, 77  GET TNPPD PICT '9'
  READ
*TOTAL
*  all asterisks (**)
*  @ 10, 36  GET  TOTLINE
*  @ 10, 39  GET  TOTFUND
*  @ 10, 42  GET  TOTACCT
*  @ 10, 47  GET  TOTFUNC
*  @ 10, 51  GET  TOTOBJ
*  @ 10, 55  GET  TOTDETAIL
*  @ 10, 73  GET  TOTPT
*  @ 10, 75  GET  TOTTR
*  @ 10, 77  GET  TOTPD
*  READ
*LESS RETAINAGE
  @ 11,24 GET EST_HEAD->PERC_RET PICTURE "99.9"
  IF AT("CO BD OF SUP",MCONT_NAME)<>0
**    @ 11, 36  GET  RETLINE
  ENDIF
  REPL RETFUNC WITH TPCFUNC
  REPL RETDETAIL WITH TPCDETAIL
*  IF AT("SAP",EST_HEAD->PROJ_PFX)<>0.OR.AT("LSBP",EST_HEAD->PROJ_PFX)<>0;
*    .OR.(AT('DECD',EST_HEAD->PROJ_PFX)<>0.AND.MFUND="81")

  IF EST_HEAD->FUND='81'.OR.EST_HEAD->FUND='99'
    REPL RETFUND WITH 'XX'
    REPL RETACCT WITH 'XXXX'
    REPL RETFUNC WITH 'XXX'
    REPL RETOBJ WITH 'XXX'
    @ 11, 39  SAY  RETFUND COLOR G+/B
    @ 11, 42  SAY  RETACCT COLOR G+/B
    @ 11, 47  SAY  RETFUNC COLOR G+/B
    @ 11, 51  SAY  RETOBJ COLOR G+/B
  ELSE
    if project->emat=.f.
      REPL RETACCT WITH '4411'
      REPL RETOBJ WITH '353'
    endif
    REPL RETFUND WITH TPCFUND
    REPL RETFUNC WITH TPCFUNC
    @ 11, 39  GET  RETFUND PICT '99'
    @ 11, 42  GET  RETACCT PICT '9999'
    @ 11, 47  GET  RETFUNC PICT '999'
    @ 11, 51  GET  RETOBJ PICT '999'
  ENDIF
  @ 11, 55  SAY  RETDETAIL COLOR G+/B
  @ 11, 73  GET  RETPT PICT '9'
  @ 11, 75  GET  RETTR PICT '9'
  @ 11, 77  GET  RETPD PICT '9'
  READ
* CD'S ON DEPOSIT
  @ 13, 11 GET EST_HEAD->CD_ON_DEP PICTURE "99,999.99"
  READ
* TOTAL DUE - REGULAR WORK
* all asterisks (**)
* @ 12, 36  GET  TWDLINE
* @ 12, 39  GET  TWDFUND
* @ 12, 42  GET  TWDACCT
* @ 12, 47  GET  TWDFUNC
* @ 12, 51  GET  TWDOBJ
* @ 12, 55  GET  TWDDETAIL
* @ 12, 73  GET  TWDPT
* @ 12, 75  GET  TWDTR
* @ 12, 77  GET  TWDPD
* READ
* EXTRA LINE
* leave blank
* @ 13,  3  SAY BLKDESC
* @ 13, 36  GET BLKLINE
* @ 13, 39  GET BLKFUND
* @ 13, 42  GET BLKACCT
* @ 13, 47  GET BLKFUNC
* @ 13, 51  GET BLKOBJ
* @ 13, 55  GET BLKDETAIL
* @ 13, 73  GET BLKPT
* @ 13, 75  GET BLKTR
* @ 13, 77  GET BLKPD
* READ
* LIQUIDATED DAMAGES
  REPL LDPT WITH '1'
  IF AT("CO BD OF SUP",MCONT_NAME)<>0
**    @ 16, 36  GET  LDLINE
  ENDIF
  REPL LDFUNC WITH TPCFUNC
  REPL LDDETAIL WITH TPCDETAIL
*  IF AT("SAP",EST_HEAD->PROJ_PFX)<>0.OR.AT("LSBP",EST_HEAD->PROJ_PFX)<>0;
*    .OR.(AT('DECD',EST_HEAD->PROJ_PFX)<>0.AND.MFUND="81")

  IF EST_HEAD->FUND='81'.OR.EST_HEAD->FUND='99'
    REPL LDFUND WITH 'XX'
    REPL LDACCT WITH 'XXXX'
    REPL LDFUNC WITH 'XXX'
    REPL LDOBJ WITH 'XXX'
    @ 16, 39  SAY  LDFUND COLOR G+/B
    @ 16, 42  SAY  LDACCT COLOR G+/B
    @ 16, 47  SAY  LDFUNC COLOR G+/B
    @ 16, 51  SAY  LDOBJ COLOR G+/B
  ELSE
    if project->emat=.f.
      REPL ldACCT WITH '4421'
      REPL ldOBJ WITH '352'
    endif
    REPL LDFUND WITH TPCFUND
    REPL LDFUNC WITH TPCFUNC
    @ 16, 39  GET  LDFUND PICT '99'
    @ 16, 42  GET  LDACCT PICT '9999'
    @ 16, 47  GET  LDFUNC PICT '999'
    @ 16, 51  GET  LDOBJ PICT '999'
  ENDIF
  @ 16, 55  SAY  LDDETAIL COLOR G+/B
  @ 16, 73  GET  LDPT PICT '9'
  @ 16, 75  GET  LDTR PICT '9'
  @ 16, 77  GET  LDPD PICT '9'
  READ
** all blank
** FUEL ADJUSTMENT
** @ 16, 37  GET  FMLINE
** @ 16, 40  GET  FMFUND
** @ 16, 43  GET  FMACCT
** @ 16, 48  GET  FMFUNC
** @ 16, 52  GET  FMOBJ
** @ 16, 56  GET  FMDETAIL
** @ 16, 74  GET  FMPT
** @ 16, 76  GET  FMTR
** @ 16, 78  GET  FMPD
** READ
** TESTIING
** @ 17, 37  GET  TLINE
** @ 17, 40  GET  TFUND
** @ 17, 43  GET  TACCT
** @ 17, 48  GET  TFUNC
** @ 17, 52  GET  TOBJ
** @ 17, 56  GET  TDETAIL
** @ 17, 74  GET  TPT
** @ 17, 76  GET  TTR
** @ 17, 78  GET  TPD
** READ
** all blank
* TOTAL NET WORK DUE
* all asterisks (**)
* @ 17, 36  GET  TNWLINE
* @ 17, 39  GET  TNWFUND
* @ 17, 42  GET  TNWACCT
* @ 17, 47  GET  TNWFUNC
* @ 17, 51  GET  TNWOBJ
* @ 17, 55  GET  TNWDETAIL
* @ 17, 73  GET  TNWPT
* @ 17, 75  GET  TNWTR
* @ 17, 77  GET  TNWPD
* READ
 IF TPCACCT=SPACE(4).OR.TPCFUNC=SPACE(3).OR.TPCOBJ=SPACE(3).OR.;
    TNPACCT=SPACE(4).OR.TNPFUNC=SPACE(3).OR.TNPOBJ=SPACE(3).OR.;
    EST_HEAD->PERC_RET=0.OR.RETACCT=SPACE(4).OR.RETFUNC=SPACE(3).OR.;
    RETOBJ=SPACE(3).OR.LDACCT=SPACE(4).OR.LDFUNC=SPACE(3).OR.;
    LDOBJ=SPACE(3)
   WARN3="ERROR!  NOT ALL ITEMS HAVE BEEN CODED."
   WYN=.F.
   ?? CHR(7)
   DO WARNING
   LOOP
 ENDIF
  DO WHILE .T.
    CLEA TYPE
    ACTIVATE MENU SHM_2
    IF PAD()=' '
      ?? CHR(7)
      LOOP
    ENDIF
    EXIT
  ENDDO
  IF PAD()='ED'
    LOOP
  ENDIF
 EXIT
ENDDO
DO WHILE .T.
  DO SCRT
  @ 3, 3   SAY "Quantities Checked                                                    "
  @ 4, 3   SAY "                                                                      "
  @ 5, 3   SAY "Original Signed ______________________  Contract Working Days         "
  @ 6, 3   SAY "                  County Engineer                                     "
  @ 7, 3   SAY "                                                                      "
  @ 8, 3   SAY "                                                                      "
  @ 9, 3   SAY "Approved: ____________________________  Working Days Used             "
  @ 10, 3  SAY "                  State Aid Engineer                                  "
  @ 11, 3  SAY "                                        Percent Complete              "
  @ 12, 3  SAY "                                                                      "
  @ 13, 3  SAY "                                        Precent Elapsed Time          "
  @ 14, 3  SAY "                                                                      "
*  IF AT("SAP",EST_HEAD->PROJ_PFX)<>0.OR.AT("LSBP",EST_HEAD->PROJ_PFX)<>0;
*    .OR.(AT('DECD',EST_HEAD->PROJ_PFX)<>0.AND.MFUND="81")

  IF EST_HEAD->FUND='81'.OR.EST_HEAD->FUND='99'
    @ 13, 3  SAY "Chief Engineer By ____________________ "
    @ 14, 3  SAY "                  Contracts Admin. Eng."
  ENDIF
  @ 15, 3  SAY "                                                                      "
  @ 16, 3  SAY "                                        "
** @ 3, 62  GET  COMPDATE
  @ 5, 66 GET EST_HEAD->TIME_UNITS PICT "!!!"
**    @ 9, 3   GET  PROJ_ENG
  READ
  IF EST_HEAD->TIME_UNITS=SPACE(5)
    WARN3="ERROR!  CONTRACT WORKING DAYS HAVE NOT BEEN CODED."
    WYN=.F.
    ?? CHR(7)
    DO WARNING
    LOOP
  ENDIF
  DO WHILE .T.
    CLEA TYPE
    ACTIVATE MENU SHM_2
    IF PAD()=' '
      ?? CHR(7)
      LOOP
    ENDIF
    EXIT
  ENDDO
  IF PAD()='ED'
    LOOP
  ENDIF
  EXIT
ENDDO
SELECT 1
REPL EMAT WITH .T.
CLOSE DATA
RETURN                                          && PROCEDURE A_U_CAD

PROCEDURE GET_VEND                              && SELECT VENDOR INFO FROM MENU
*-----------------
?? CHR(7)
SELECT 6
USE AV0001 ORDER NAME
**SET COLOR OF BOX TO GR+/BG
DEFINE WINDOW VENDOR FROM 11,11 TO 23,69 COLOR ,,GR+/BG
**SET COLOR OF BOX TO W+/B
@ 24,0 TO 24,79 COLOR R/R
@ 24, 8 SAY "Position selection bar - "+CHR(24)+" "+CHR(25)+".  Select - "+CHR(17)+CHR(217)+".  Leave menu - "+CHR(27)+" "+CHR(26)+"." COLOR W+/R
ACTIVATE WINDOW VENDOR
SET COLOR OF BOX TO W+/B
DEFINE POPUP VEND_R FROM 4,12 TO 10,46 PROMPT FIELD AVENM COLOR ,,W+/B SCROLL
ON SELECTION POPUP VEND_R DEACTIVATE POPUP
DO WHILE .T.
  @ 1, 8 SAY "Select from the list of approved vendors."
  @ 3, 1 SAY "Scroll list using arrow keys and press ENTER to select."
  CLEA TYPE
  ACTIVATE POPUP VEND_R
  IF PROMPT()<>' '
    VEND_NM=PROMPT()
    SEEK VEND_NM
    EXIT
  ELSE
    DO WHILE .T.
      CLEA TYPE
      ANS=' '
      @ 1, 0
      @ 3, 0
      @ 3, 7 SAY "VENDOR INFORMATION NOT SELECTED FROM LIST."
      @ 5, 2 SAY "ADD OR EDIT VENDOR INFORMATION OR RE-TRY? (A/E/R) " GET ANS PICT '!'
      READ
      DO SCRT
      DEFINE WINDOW VW_1 FROM 4,11 TO 21,69 DOUBLE COLOR W+/B,GR+/R,GR+/BG SHADOW
      DO CASE
        CASE ANS='A'
          ACTIVATE WINDOW V_COVER
          DO VENDAPPN
          DEACTIVATE WINDOW V_COVER
        CASE ANS='E'
          ACTIVATE WINDOW V_COVER
          DO VENDEDIT
          DEACTIVATE WINDOW V_COVER
        CASE ANS='R'
        OTHERWISE
          ?? CHR(7)
          LOOP
      ENDCASE
      release window vw_1
      EXIT
    ENDDO
  ENDIF
ENDDO
RELEASE POPUP VEND_R
DEACTIVATE WINDOW VENDOR
RELEASE WINDOW VENDOR
@ 24, 0
RETURN                                          && PROCEDURE GET_VEND

PROCEDURE D_HEAD                                && DELETE HEADER SET FOR SPECIFIED PROJECT
*---------------
DO GET_PROJ             && SELECT PROJECT
**CLOSE DATA
SELECT 1
USE PROJECT ORDER PROJ
SEEK MPROJ
IF .NOT. RLOCK()
  ACCESS=.F.
  RETURN
ENDIF
SELECT 3
USE DHEADER
IF .NOT. ACCESS
  RETURN
ENDIF
DO LOCK_DEL
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE DHEADER EXCLUSIVE
ENDIF
SELECT 4
USE EST_HEAD
IF .NOT. ACCESS
  RETURN
ENDIF
DO LOCK_DEL
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE EST_HEAD EXCLUSIVE
ENDIF
SELECT 5
USE ACCT001
IF .NOT. ACCESS
  RETURN
ENDIF
DO LOCK_DEL
IF NO_LOCK=.T.
  RETURN
ELSE
  UNLOCK
  USE ACCT001 EXCLUSIVE
ENDIF
DO WHILE .T.
  WARN2='DELETE HEADER SET FOR'
  WARN3=ALLT(MPROJ)
  ?? CHR(7)
  DO WARNING
  IF PAD()=' '
    LOOP
  ENDIF
  EXIT
ENDDO
IF PAD()='YEA'
  DO WHILE .T.
    WARN1='LAST CHANCE!!'
    WARN2='DELETE HEADER SET FOR'
    WARN3=ALLT(MPROJ)
    ?? CHR(7)
    DO WARNING
    IF PAD()=' '
      LOOP
    ENDIF
    EXIT
  ENDDO
  IF PAD()='YEA'
    XYZ=BOX('DELETING HEADER SET FOR '+ALLT(MPROJ),12)
    SELECT 1
    PN=PROJ_NUM
    REPL ENGR WITH .F.
    REPL S900 WITH .F.
    REPL S902 WITH .F.
    REPL EMAT WITH .F.
    SELECT 3
    DELETE ALL FOR ALLTRIM(PROJ_NO)=MPROJ
    PACK
    APPEND BLANK
    REPL PROJ_NO WITH PROJECT->PROJECT
    REPL COUNTY WITH PROJECT->COUNTY
    REPL FUND WITH PROJECT->FUND
    REPL FANUM WITH PROJECT->FANUM
    REPL SEC WITH PROJECT->SEC
    REPL UNIT WITH PROJECT->UNIT
    REPL PT WITH PROJECT->PT
    REPL PROJ_NUM WITH PROJECT->PROJ_NUM
    REPL UNITS WITH PROJECT->UNITS
    SELECT 4
    DELETE ALL FOR PROJ_NUM=PN
    PACK
    APPEND BLANK
    REPL PROJ_PFX WITH PROJECT->PROJECT
    REPL COUNTY WITH PROJECT->COUNTY
    REPL FUND WITH PROJECT->FUND
    REPL FANUM WITH PROJECT->FANUM
    REPL SEC WITH PROJECT->SEC
    REPL UNIT WITH PROJECT->UNIT
    REPL PT WITH PROJECT->PT
    REPL PROJ_NUM WITH PROJECT->PROJ_NUM
    REPL PERC_RET WITH 5
    REPL NUM_PAGES WITH 2
    SELECT 5
    DELETE ALL FOR PROJ_NUM=PN
    PACK
    APPEND BLANK
    REPL PROJECT WITH PROJECT->PROJECT
    REPL PROJ_NUM WITH PROJECT->PROJ_NUM
    ZD_CX=PROJECT->FUND+'-'+PROJECT->FANUM+'-'+PROJECT->SEC+'-'+PROJECT->UNIT+'-'+PROJECT->PT
    REPL TPCDETAIL WITH ZD_CX
    REPL TNPDETAIL WITH ZD_CX
    REPL TOTDETAIL WITH ZD_CX
    REPL TWDDETAIL WITH ZD_CX
    REPL RETDETAIL WITH ZD_CX
    REPL LDDETAIL WITH ZD_CX
    DEACTIVATE WINDOW BOX
  ENDIF
ENDIF
CLOSE DATA
IF PAD()='NAY'
  WARN2="THE HEADER SET FOR "+ALLT(MPROJ)
  WARN3="WAS NOT DELETED."
  WYN=.F.
  DO WARNING
ENDIF
RETURN                                          && PROCEDURE D_HEAD

PROCEDURE LOCK_NEW                              && FILE LOCKING FOR NEW RECORDS
*-----------------
IF .NOT. FLOCK()
  CLOSE DATA
  WYN=.F.
  WARN2='HEADER FILE IN USE BY ANOTHER,'
  WARN3='CANNOT ADD RECORDS AT THIS TIME.'
  ?? CHR(7)
  DO WARNING
  NO_LOCK=.T.
ENDIF
RETURN                                          && PROCEDURE LOCK_NEW

PROCEDURE LOCK_EDT                              && RECORD LOCKING FOR EDITING
*-----------------
IF .NOT. RLOCK()
  CLOSE DATA
  WYN=.F.
  WARN2='SELECTED HEADER RECORD IN USE BY ANOTHER,'
  WARN3='PROJECT CANNOT EDITED AT THIS TIME.'
  ?? CHR(7)
  DO WARNING
  NO_LOCK=.T.
  RETURN
ENDIF
RETURN                                          && PROCEDURE LOCK_EDT
***<<<<<>>>>>***


